#!/bin/bash

# Usage :
# bash smbcc.sh <chemin du partage Windows AVEC IP> <nom d'utilisateur/mot de passe> <action> <clé d'encryption>

# Déclaration des variables.
chemin=$1
cred=$2
action=$3
ficcle=$4

# Récupération du nom d'utilisateur et du mot de passe.
user=$(echo $cred| cut -d "/" -f1)
pass=$(echo $cred| cut -d "/" -f2)

# Création du répertoire s'il n'existe pas, et montage du partage Samba dessus.
[[ -e /tmp/samba ]] || mkdir /tmp/samba
mount.cifs -o "username=$user,password=$pass" "//${chemin}" /tmp/samba

# Première vérification d'erreurs.
if [[ $? != 0 ]] ; then
	echo "Erreur dans la commande mount.cifs, vérifiez les paramètres entrés."
	rmdir /tmp/samba
	exit 1
fi

# Commande ccrypt pour encrypter ou décrypter le répertoire avec le partage.
ccrypt "$action" --recursive --key $ficcle /tmp/samba

# Seconde vérification d'erreurs.
if [[ $? != 0 ]] ; then
	echo "Échec de ccrypt, veuillez relancer le script après avoir vérifié les paramètres."
	umount /tmp/samba
	exit 1
fi

# Nettoyage des directoires, et sortie du script avec le code 0.
umount /tmp/samba
rmdir /tmp/samba
exit 0
